import java.util.PriorityQueue;

/**
 *
 * @author Joost
 */
public interface GeneticStrategy {
	
	public double fitness(Specimen s);
	
	public void iterate(PriorityQueue<Specimen> population);
	
	public Specimen getFittestSpecimen(PriorityQueue<Specimen> population);
}
